<?php
namespace PHPSQLParser;
require_once dirname(__FILE__) . '/PHP-SQL-Parser-master/vendor/autoload.php';

class namer{
    protected $sql_parser;
    private $tables;
    private $conditions;
    private $conditioned;
    
    function __construct(){
            $this->sql_parser =  new PHPSQLParser();
    }
 
 public function makeKey(string $query){
    $iterations = 100;
    //echo "making a new query key";
    $salt = 88; //originally was random
    $length = 4;
    
    $hash = hash_pbkdf2("crc32", $query, $salt, $iterations, $length);
    return $hash; //unique id for the query
    }
 public function makeServiceName(string $query){
     return $this ->makeQueryName($query).'_service.js';
 }
 public function makeExposeName(string $query){
     return 'expose_'.$this ->makeQueryName($query).'.php';
 } //OR MAKE_QUERY_FUNCTION_NAME??????
   
 public function makeChildName(string $q){
     return $this ->makeQueryName($q);
 }   
 public function makeAngularFunctionName(string $q){
     return ($this -> makeChildName($q)).'_request';
 }
 
 public function makeAngularUrlAddress(string $q){
     $pre_path = '';  //TODO
     return $pre_path.($this -> makeExposeName($q)); 
 }
 public function makeQueryName(string $q){//TODO make it protected
      /*se un solo from con una sola colref utilizzare quella
      * altrimenti se presente un Joint utilizzare entrambe le colref/[table] A&B
      * se più di un JOIN utilizzare le prime due (o quelle presenti con maggior frequenza)
      * se presente un WHERE on un  ON aggiungere 'condition????'
      * appendere unique_id(hash) at the end.
      * 
      * 
      */
     
      $q = str_replace("'", "\"" ,$q);
      $result_name = '';
      $this ->conditioned = FALSE;
      $this->conditions = [];
      $this -> tables=[];
      $pars_result = $this -> sql_parser ->parse($q);
    
      $this->array_walk_recursive($pars_result, array(&$this,'collect_info'));
      
        //var_dump($pars_result);

      if ($this->conditioned) {
          $j = 0;
          while (empty($this->conditions)) {
              $this -> array_walk_recursive($pars_result['FROM'][$j++]['ref_clause'], array(&$this,'condition_entity'));
              if($j > 10) break; //not too deeper
          }
          
      }
      //var_dump($pars_result['FROM'][1]['ref_clause']);
    
     
      $this -> conditions = array_count_values($this -> conditions);
      $this -> tables = array_count_values($this -> tables);
     
      //var_dump($this -> conditions);
     // var_dump($this -> tables);
     //forse sono già in ordine
      $this -> tables = array_merge($this->tables);
      $this -> conditions = array_merge($this -> conditions);
      
      //var_dump($this -> conditions);
      //var_dump($this -> tables);
      
            end($this -> tables);
            $key = key($this -> tables);
            $result_name = $key;
            unset($this -> tables[$key]);
      if(count($this->tables)>0){
            end($this -> tables);
            $key = key($this -> tables);
           unset($this -> tables[$key]);
          
          $result_name .= 'WITH'.$key; //TODO il carattere '?' potrebbe non essere quello più giusto semanticamente
      }
      if(count($this->conditions)>0){
          end($this->conditions);
          $key = key($this->conditions);
          unset($this->conditions[$key]);
          
          $result_name .= 'CON'.str_replace('.', '',$key);
      }
      return $result_name.$this->makeKey($q);
      //--------var_dump($pars_result['FROM'][0]['ref_clause']);
     
      
 }
 public  function collect_info(&$item, $key){
           
            if($key === 'table'){
          
                array_push($this->tables,$item);
            }
            if($key === 'ref_type' && ($item === 'ON'| $item ==='WHERE')){
                $this ->conditioned = TRUE;               
                //need to get first base_expression of next colref_expression 
            }
            
            //example echo "$key holds $item\n";
    }
 
 public function condition_entity(&$item, $key){
     if($key === 'base_expr' && is_string($item) && ctype_alnum((str_replace('.', '', $item)))){ //&&  ctype_alpha($item) replace dot and is alphanumeric

        $this -> conditions[] = $item;
            //break; una è suff
     }
     
 }
 
//--- array_walk definitions-----
/*
 Usage:
<?php
$arr = array(
  'a' => '"Hello World"',
  'b' => "'Hello World'",
  'c' => "Hello 'Worl\"d",
  'd' => array(
    'A' => 'H"e"l"l"o" "W"o"r"l"d'
    )
  );

$class = new A_Class();
$class->array_walk_recursive($arr, array(&$class, 'kv_addslashes'));
print_r($arr);
*/

function array_walk_recursive(&$input, $funcname, $userdata = '') {
  if(!function_exists('array_walk_recursive')) {
    if(!is_callable($funcname))
      return false;

    if(!is_array($input))
      return false;

    foreach($input as $key=>$value) {
      if(is_array($input[$key])) {
        if(isset($this)) {
          eval('$this->' . __FUNCTION__ . '($input[$key], $funcname, $userdata);');
        } else {
          if(@get_class($this))
            eval(get_class() . '::' . __FUNCTION__ . '($input[$key], $funcname, $userdata);');
          else
            eval(__FUNCTION__ . '($input[$key], $funcname, $userdata);');
        }
      } else {
        $saved_value = $value;

        if(is_array($funcname)) {
          $f = '';
          for($a=0; $a<count($funcname); $a++)
            if(is_object($funcname[$a])) {
              $f .= get_class($funcname[$a]);
            } else {
              if($a > 0)
                $f .= '::';
              $f .= $funcname[$a];
            }
          $f .= '($value, $key' . (!empty($userdata) ? ', $userdata' : '') . ');';
          eval($f);
        } else {
          if(!empty($userdata))
            $funcname($value, $key, $userdata);
          else
            $funcname($value, $key);
        }

        if($value != $saved_value)
          $input[$key] = $value;
      }
    }
    return true;
  } else {
    array_walk_recursive($input, $funcname, $userdata);
  }
}

/*  sample inside class user defined function---
function kv_addslashes(&$v, $k) {
  $v = addslashes($v);
}
 */
 
 
}

/*---------- testing namer functions---------
$nmr = new namer();

$q='select u from(
select utentericevente as u from amicizia where utenterichiedente = "martino.coffey@fastwebnet.it" and stato = "c"
union 
select utenterichiedente as u from amicizia   where utentericevente = "martino.coffey@fastwebnet.it" and stato = "c"
) as alias  join (select email from utente where residenza = (select residenza  from utente where email = "martino.coffey@fastwebnet.it")) as alias2 on alias.u = alias2.email 
join (select email from utente where (SELECT EXTRACT(YEAR FROM now())-EXTRACT(YEAR from datanascita)) = (select (SELECT EXTRACT(YEAR FROM now())-EXTRACT(YEAR from datanascita))  from utente where email = "martino.coffey@fastwebnet.it" ))as alias3 on alias3.email = alias.u';
var_dump($nmr -> makeQueryName($q) );
 * 
 */
?>